# -*- coding: utf-8 -*-
#!/usr/bin/env python
import numpy
import string
import os
import matplotlib.pyplot as plt
from scipy.optimize import curve_fit
from pylab import *
from scipy import constants
import glob

###Popis kodu
#Vstupom su 2 subory, 1)priblizne polohy vlnovych dlzok spektralnych ciar 2)samotne data v ascii formate
#program postupne prespracovava data do podoby kde najde konkretnu spektralnu ciaru v spektre
#a nasledne ju fituje gaussovou funkciou. danu ulohu program opakuje pre rozne druzicove merania a nasledne
#ich vsetky vykresli do grafov s nafitovanymi hodnotami. Program to zopakuje pre vsetky spektralne ciary
#zadane v subore polohy.txt
#tymto programom som studoval premennosť spektralnych ciar hviezdy počas periody jej rotacie
#program som v tej dobe nepisal este cez funkcie tak snad to nebude prilis vadit

###definovane funkcie gaussa
def gaus(x,I0,A,x0,sigma):
    return I0*exp(-A*exp(-(x-x0)**2/(2*sigma**2)))

if os.path.exists("./vysledok") == False:
	os.mkdir("vysledok")
f=open('./spektra/polohy.txt')
polohy=[]
for line in f:
    polohy.append(string.split(line))
f.close()


####zmena na float
for i in range (len(polohy)):
    #alfa to float (atof)
    polohy[i][0]=string.atof(polohy[i][0])
    polohy[i][1]=string.atof(polohy[i][1])
    polohy[i][2]=string.atof(polohy[i][2])
    
#for cyklus pracuje s jednotlivymi ciarami
for j in range (len(polohy)): 
    FWgauss=[]
    FWgausserr = []
    mini=[]
    minierr=[]
    v=[]
    deltav=[]
    fi = []
    poradie = []
    fi80 = []
    v80=[]
    mini80=[]
    FWgauss80=[]
    JD0 = 2444953.68765
    
    dolnyparameter= polohy[j][0]
    hornyparameter= polohy[j][1]
    stred = (dolnyparameter + hornyparameter)/2
    lambda0= polohy[j][2]*10**(-10)
    deltalambda0=0.05*10**(-10)
    print 'čiara.............................', stred  



###nacitanie suborov zo zlozky
    for files in glob.glob('./spektra/sp*.txt'):
        profil = []
        minim = []
        P=[]
        
        g=open(files)
        data=[]
        k=0
        b=g.readline()#1
        nazov = g.readline() #na druhom riadku je nazov
        for i in range(13):
            b=g.readline()
        JD = g.readline() #na 16 riadku je julianske datum
        for i in range(3):
            b=g.readline()
        for line in g: #od 20 riadku su data
            data.append(string.split(line))
        g.close()
        
        faza = (float(JD)-JD0)/1.19081 #podelene periodov rotacie
        if faza<0:
            fazax = abs(faza-int(faza)) #zobere cislo za desatinnou ciarkov
            fi80.append(fazax)###tvori specialny list pre 1981 koli vykresleniu inou farbou
            faza = faza + 593
#potreba tvorit specialny list poloh z roku 80 pretoze merania su odseba vzdialene 2 roky            
        fazax = abs(faza-int(faza))
        poradie.append(faza)
        fi.append(fazax)
####zmena na float
        tabulka=[]
        k=0
        for m in range (len(data)):
            #alfa to float (atof)            
            data[m][0]=string.atof(data[m][0])
            l = 0.05*k +1150
            k=k+1
            data[m].append(l)
            if data[m][0]>0:
                tabulka.append([data[m][3],data[m][0]])
                
###vytriedenie dat zakl. parametrami
        for l in range (len(tabulka)):
            if tabulka[l][0]>=dolnyparameter and tabulka[l][0]<=hornyparameter:
                profil.append(tabulka[l])
                minim.append(tabulka[l][1])
#vyhladanie indexu minima
		
        indexmin = minim.index(min(minim)) #urcenie indexu vlnvej dlzky minima spek. ciary

####vytriedenie dat od minima na obe strany 
##ak nasledujuce dva body znova klesnu sekne data, inak ukonci parametrom
        k=indexmin
        while profil[k-1][1] >0:
            P.append(profil[k-1])
            k=k-1
    
            if profil[k-2][0] == dolnyparameter:
                break    

        P.reverse()  #reverse lebo sme isli zprava do lava           
        k=indexmin   
        P.append(profil[k]) 
        while 0 < profil[k+1][1] :
            P.append(profil[k+1])
            k=k+1
            if profil[k+2][0] == hornyparameter:
                break

###zmena na array    
        x=[]
        y=[]
        for z in range (0,len(P)):
            x.append(P[z][0])
            y.append(P[z][1])
        xx = numpy.asarray(x)
        yy = numpy.asarray(y)

####zakl odhad parametrov na fitovanie
        n = len(xx)                         
        mean = numpy.mean(xx)                  
        sigma = (sum(((xx-mean)**2)/n))**0.5  

####fitovanie    
        popt,pcov = curve_fit(gaus,xx,yy,p0=[1.0,1.0,mean,sigma])

####umele funkcie
        FWHM = 2*numpy.sqrt(2*numpy.log(2))*abs(popt[3]) #Full Width of Half Minimum
        FWHMerr = 2*numpy.sqrt(2*numpy.log(2))*numpy.sqrt(double(pcov[3][3]))
 
        vx=(constants.c*(popt[2]*10**(-10)-lambda0)/lambda0)/1000
        deltavx=(constants.c/lambda0*numpy.sqrt(pcov[2][2])*10**(-10))/1000 

        FWgauss.append(FWHM)
        FWgausserr.append(FWHMerr)
        
        mini.append(popt[2])
        minierr.append(numpy.sqrt(pcov[2][2])) 
               
        v.append(vx)
        deltav.append(deltavx)

###data 1980
        if len(nazov) == 17:
            v80.append(vx)
            mini80.append(popt[2])
            FWgauss80.append(FWHM)
            
#umela fitovacia funkcia
        xx2 = numpy.arange(min(xx),max(xx),0.01)
#gaus_color(numero)    
        
        plt.plot(xx,yy,'bo:',label='data')
        plt.plot(xx2,gaus(xx2,*popt),'r',label='Gauss fit')
        
#       plt.show()
#       plt.legend()
#grafy variaci

    plt.xlabel(u'Vlnová dlžka [$\AA$]', fontsize=15)
    plt.ylabel(u'Tok žiarenia [erg cm$^{-2}$s$^{-1}\AA ^{-1}$]', fontsize= 15)
    plt.gca().get_xaxis().get_major_formatter().set_useOffset(False)
    plt.savefig("./vysledok/fit_"+str(polohy[j][2])+"A.pdf")
#    plt.show()
    plt.gcf().clear()    

    plt.plot(fi,mini,'ro',label='1981')
    plt.errorbar(fi ,mini, minierr, marker = "None", linestyle = "None")
    plt.plot(fi80,mini80,'bo',label='1980')
    plt.xlim(-0.1,1.0)
    plt.ylim(numpy.mean(mini)-0.1,numpy.mean(mini)+0.1)
    plt.xlabel(u'Fáza', fontsize=15)
    plt.ylabel(u'Hodnota minima [$\AA$]', fontsize= 15)
    plt.gca().get_yaxis().get_major_formatter().set_useOffset(False)
    plt.legend()
    plt.savefig("./vysledok/polohaminima_"+str(polohy[j][2])+"A.pdf")
#    plt.show()
    plt.gcf().clear()

    plt.plot(fi,FWgauss,'ro',label='1981')
    plt.gca().get_xaxis().get_major_formatter().set_useOffset(False)
    plt.errorbar(fi ,FWgauss, yerr = FWgausserr, marker = "None", linestyle = "None")
    plt.plot(fi80,FWgauss80,'bo',label='1980')
    plt.xlim(-0.1,1)
    plt.ylim(-0.05,0.5)
    plt.xlabel(u'Fáza', fontsize=15)
    plt.ylabel(u'Ekvivalentná  šírka [$\AA$]', fontsize= 15)#    plt.savefig("sirka_"+str(polohy[j][2])+"A.pdf")
    plt.legend()
    plt.savefig("./vysledok/sirka_"+str(polohy[j][2])+"A.pdf")
#    plt.show()    
    plt.gcf().clear()

    plt.plot(fi,v,'ro',label='1981')
    plt.errorbar(fi ,v, deltav, marker = "None", linestyle = "None")
    plt.plot(fi80,v80,'bo',label='1980')
    plt.xlim(-0.1,1.0)
    plt.ylim(-20,40)
    plt.xlabel(u'Fáza', fontsize=15)
    plt.ylabel(u'Rýchlosť [km/s]', fontsize= 15)
    plt.legend()
    plt.savefig("./vysledok/rychlost_"+str(polohy[j][2])+"A.pdf")
#    plt.show()    
    plt.gcf().clear()
    
    plt.plot(poradie,mini,'ro',label='var minimum')
    plt.errorbar(poradie ,mini, minierr, marker = "None", linestyle = "None")
    plt.xlabel('poradie', fontsize=15)
    plt.ylabel('Minimum', fontsize= 15)
    plt.savefig("./vysledok/poradie_minima_"+str(polohy[j][2])+"A.pdf")
#    plt.show()
    plt.gcf().clear()

